Ole Troan | 5c318c7 | 2020-05-05 12:23:47 +0200 | [diff] [blame^] | 1 | #!/bin/sh |
| 2 | set -eux |
| 3 | |
| 4 | TMPDIR=$(mktemp -d /tmp/vpp-crccheck-test-XXXXX) |
| 5 | |
| 6 | CURR_ROOT=$(git rev-parse --show-toplevel) |
| 7 | CURR_DIR=$(pwd) |
| 8 | |
| 9 | verify_check_patchset_fails() { |
| 10 | if (extras/scripts/crcchecker.py --check-patchset); then |
| 11 | echo "ERROR - check succeeded, it should have failed!" |
| 12 | exit 1; |
| 13 | fi |
| 14 | } |
| 15 | |
| 16 | finish() { |
| 17 | if [ -e "$TMPDIR" ]; then |
| 18 | echo "Temporary directory is: $TMPDIR" |
| 19 | fi |
| 20 | } |
| 21 | trap finish EXIT |
| 22 | |
| 23 | |
| 24 | # make a copy of the current repo that we can play with |
| 25 | cd ${TMPDIR} |
| 26 | mkdir misc-files |
| 27 | git clone ${CURR_ROOT} vpp-uut |
| 28 | cd vpp-uut |
| 29 | |
| 30 | # maybe grab the CRC checker |
| 31 | # git fetch "https://gerrit.fd.io/r/vpp" refs/changes/81/26881/14 && git cherry-pick FETCH_HEAD || echo "Already there" |
| 32 | |
| 33 | |
| 34 | echo "TEST 1: Check the current patchset..." |
| 35 | extras/scripts/crcchecker.py --check-patchset |
| 36 | |
| 37 | echo "TEST 2: Dumping the current manifest..." |
| 38 | extras/scripts/crcchecker.py --dump-manifest >${TMPDIR}/misc-files/manifest.txt |
| 39 | |
| 40 | echo "TEST 3: Checking the 20.01 version of acl.api...." |
| 41 | extras/scripts/crcchecker.py --git-revision v20.01 src/plugins/acl/acl.api |
| 42 | |
| 43 | echo "TEST 4: Add a new field into a message in acl.api, and check patchset - must fail..." |
| 44 | sed -i -e 's#vpe_pid;#vpe_pid; u32 sneaky_new_field;#' src/plugins/acl/acl.api |
| 45 | verify_check_patchset_fails |
| 46 | |
| 47 | echo "TEST 5: Rename the changed acl.api file and not add it to git... must fail (due to deletion of the APIs)..." |
| 48 | mv src/plugins/acl/acl.api src/plugins/acl/acl_new.api |
| 49 | verify_check_patchset_fails |
| 50 | |
| 51 | echo "TEST 6: Add the renamed file to git commit... must fail (due to addition of the fields)..." |
| 52 | git add src/plugins/acl/acl_new.api |
| 53 | git commit -m "added acl_new.api" |
| 54 | verify_check_patchset_fails |
| 55 | |
| 56 | echo "TEST 7: Verify we can delete deprecated message" |
| 57 | git commit -a -m "reset" |
| 58 | cat >crccheck.api <<EOL |
| 59 | option version="1.0.0"; |
| 60 | autoreply define crccheck |
| 61 | { |
| 62 | option deprecated="v20.11"; |
| 63 | bool foo; |
| 64 | }; |
| 65 | EOL |
| 66 | git add crccheck.api |
| 67 | git commit -m "deprecated api"; |
| 68 | # delete API |
| 69 | cat >crccheck.api <<EOL |
| 70 | option version="1.0.0"; |
| 71 | autoreply define crccheck_2 |
| 72 | { |
| 73 | bool foo; |
| 74 | }; |
| 75 | EOL |
| 76 | git add crccheck.api |
| 77 | git commit -m "deprecated api"; |
| 78 | extras/scripts/crcchecker.py --check-patchset |
| 79 | |
| 80 | echo "TEST 8: Verify that we can not rename a non-deprecated message" |
| 81 | sed -i -e 's/crccheck_2/crccheck_3/g' crccheck.api |
| 82 | git add crccheck.api |
| 83 | git commit -m "renamed api"; |
| 84 | verify_check_patchset_fails |
| 85 | # fix it. |
| 86 | sed -i -e 's/crccheck_3/crccheck_2/g' crccheck.api |
| 87 | git commit -a --amend -m "empty commit after we renamed api back" --allow-empty |
| 88 | |
| 89 | echo "TEST 9: Verify that the check fails if the changes are not committed" |
| 90 | cat >>crccheck.api <<EOL |
| 91 | autoreply define crc_new_check_in_progress |
| 92 | { |
| 93 | option status="in_progress"; |
| 94 | bool foobar; |
| 95 | }; |
| 96 | EOL |
| 97 | verify_check_patchset_fails |
| 98 | |
| 99 | echo "TEST10: Verify that the in-progress message can be added" |
| 100 | git add crccheck.api |
| 101 | git commit -m "added a new in-progress api"; |
| 102 | extras/scripts/crcchecker.py --check-patchset |
| 103 | |
| 104 | echo "TEST11: Verify we can rename an in-progress API" |
| 105 | sed -i -e 's/crc_new_check_in_progress/crc_new_check_in_progress_2/g' crccheck.api |
| 106 | git add crccheck.api |
| 107 | git commit -m "renamed in-progress api"; |
| 108 | extras/scripts/crcchecker.py --check-patchset |
| 109 | |
| 110 | echo "TEST12: Verify we can add a field to an in-progress API" |
| 111 | sed -i -e 's/foobar;/foobar; bool new_baz;/g' crccheck.api |
| 112 | git add crccheck.api |
| 113 | git commit -m "new field added in in-progress api"; |
| 114 | extras/scripts/crcchecker.py --check-patchset |
| 115 | |
| 116 | echo "TEST13: Verify we fail the check if the file can not be compiled" |
| 117 | cat >crccheck2.api <<EOL |
| 118 | option version="0.0.1"; |
| 119 | autoreply define spot_the_error |
| 120 | { |
| 121 | option status="in_progress" |
| 122 | bool something_important; |
| 123 | }; |
| 124 | EOL |
| 125 | git add crccheck2.api |
| 126 | git commit -m "a new message with a syntax error"; |
| 127 | verify_check_patchset_fails |
| 128 | |
| 129 | # get rid of the "erroneous" commit in the previous test |
| 130 | git reset --hard HEAD~1 |
| 131 | |
| 132 | echo "TEST: All tests got the expected result, cleaning up." |
| 133 | |
| 134 | # done with all the tests - clean up |
| 135 | cd ${CURR_DIR} |
| 136 | |
| 137 | # beware of empty variables, careful with deletion |
| 138 | rm -rf ${TMPDIR}/vpp-uut |
| 139 | rm -rf ${TMPDIR}/misc-files |
| 140 | rmdir ${TMPDIR} |